   program

   map
      main
   end


!------------------------------------------------------------!
! You may not make any changes to DelimQueue or
! ParserBaseClass.
!------------------------------------------------------------!
DelimQueue           queue
Delim                   string(1)
                     end

ParserBaseClass      class,type
DelimQ                  &DelimQueue
Text                    string(1000)
!--- methods ------------------------------------------------!
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetString               procedure,string,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
Init                    procedure
Kill                    procedure
PutToken                procedure(long Index,string Text),byte,virtual,proc
Reset                   procedure,virtual
SetString               procedure(string Text),virtual
!------------------------------------------------------------!
! Do NOT derive the Test procedure. All derived classes
! have to use the base class's test.
!------------------------------------------------------------!
Test                    procedure
                     end

!------------------------------------------------------------!
! MyParser is the class declaration you can make changes to
! if you wish. You may want to add variables to this class.
!------------------------------------------------------------!
MyParser             class(ParserBaseClass)
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
PutToken                procedure(long Index,string Text),byte,virtual,proc
                     end


   code
   main()



main     procedure



    map
    end

Count       Long
Ending      Long
NextDay     long
Starting    Long
x           short

ResultsQ    queue
Name           string(30)
Elapsed        decimal(5,2)
Text           string(1000)
Index          byte
            end



Window WINDOW('Parser Test'),AT(,,422,108),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI),CENTER, |
         ICON('Clarion.ico'),GRAY,DOUBLE
       PROMPT('No. Of Tests:'),AT(4,7),USE(?Prompt4)
       SPIN(@n9),AT(56,7,60,10),USE(Count)
       LIST,AT(4,23,409,65),USE(?List1),FORMAT('90L(2)|M~Name~@s30@31L(2)|M~Elapsed~@n5.2@20L(2)|M~Result~@s255@'), |
           FROM(ResultsQ)
       BUTTON('&Calculate'),AT(119,92,45,14),USE(?Calculate),DEFAULT
       BUTTON('C&lose'),AT(257,92,45,14),USE(?Close),STD(std:close)
     END

StartTime      ulong
EndTime        ulong
 
   Code
   Count = 2000
   clear(ResultsQ)
   ResultsQ.Index = 1
   ResultsQ.Name = 'Test'
   MyParser.Init()
   add(ResultsQ)
   Open(Window)
   post(event:accepted,?Calculate)
   Accept
      Case accepted()
      of ?Calculate
         setcursor(cursor:wait)
         sort(ResultsQ,ResultsQ.Index)
         loop x = 1 to records(ResultsQ)
            get(ResultsQ,x)
            StartTime = clock()
            loop Count times
               execute x
                  MyParser.Test()
               end
            end
            execute x
               ResultsQ.Text = MyParser.GetString()
            end
            ResultsQ.Elapsed = (clock() - StartTime)/100
            put(ResultsQ)
         end
         sort(ResultsQ,ResultsQ.Elapsed)
         setcursor()
         display()
      end
   end
   MyParser.Kill()


!!--- methods ------------------------------------------------!
ParserBaseClass.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.BeforeTest              procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.GetString               procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(self.Text)

ParserBaseClass.GetTokenCount           procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(0)

ParserBaseClass.GetToken                procedure(long Index)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return('')


ParserBaseClass.Init                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.DelimQ &= new DelimQueue

ParserBaseClass.Kill                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   free(self.DelimQ)
   dispose(self.DelimQ)

ParserBaseClass.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(False)

ParserBaseClass.Reset                   procedure
   code
   free(self.DelimQ)
   clear(self.Text)

ParserBaseClass.SetString               procedure(string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.Text = Text

ParserBaseClass.Test                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.SetString('This is the test string, which should have its words alternating between '|
      & 'upper case and lower case. The actual test will parse Clarion code and capitalize keywords.')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      if x % 2
         TempString = upper(TempString)
      else
         TempString = lower(TempString)
      end
      self.PutToken(x,TempString)
   end
   return

!------------------------------------------------------------!
! You may not modify anything above this point except for
! the MyParser class declaration at the top of the file.
!------------------------------------------------------------!


MyParser.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! You don't need to modify this method but you may wish to
! if you have a better idea for how to store delimiters.
! By default this method adds records to the DelimQ. To get
! the delimiters that have been added you can query the queue
! as you would any other queue. If you have questions about
! this email advisor@clarionmag.com.
!------------------------------------------------------------!
   code
   self.DelimQ.Delim = Delim
   add(self.DelimQ)

MyParser.BeforeTest              procedure
!------------------------------------------------------------!
! Write code here to prepare for the test, if necessary.
! This method is called automatically by the test procedure
! before the test is run. You will most likely want to use
! this method if you parse your string before calling any of
! the string manipulation methods. If you do everything
! on the fly then you probably won't need this method
!------------------------------------------------------------!
   code

MyParser.GetTokenCount           procedure
!------------------------------------------------------------!
! Write code here to count the number of tokens. By default
! you have a queue (self.DelimQ) of delimiters which you
! can use to examine the text string (self.Text).
!------------------------------------------------------------!
   code
   return(0)  ! Replace this code!

MyParser.GetToken                procedure(long Index)
!------------------------------------------------------------!
! Write code here to get a specific token. In the example
! text a token is an individual words, but if the string
! were some Clarion code and the period is a delimiter then
! if the string were "MyParser.GetToken" GetToken(1) would
! return "MyParser" and GetToken(2) would return "GetToken"
!------------------------------------------------------------!
   code
   return('')  ! Replace this code!

MyParser.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! Write code here to set a specified token in the string to
! a new value. For instance, if the string is
! "MyParser.GetToken" and the period is a delimiter then
! calling PutToken(1,'SomeOtherParser') would change the
! string to "SomeOtherParser.GetToken".
!------------------------------------------------------------!
   code
   return(False)  ! Replace this code!




